p2=101, p1=100, p0=99, n1=0.5, u1=0, u2=0
beta=50, R=1.01, Dividend=1, v=0.5, g=2.1, C=0, w=0, a=1, delta=0, alpha=10, sigma=0, noisetype=0
n2
d
pstar=Dividend/(R-1)
pf=pstar+v*(p2-pstar)
pt=p2+g*(p2-p1)
pf0=pstar+v*(p1-pstar)
pt0=p1+g*(p1-p0)

n2=1-n1
s=n1*pf+n2*pt

--Noisy equilibrium
if noisetype==0 then eps=(2*math.random()-1)*sigma 
else 
  e1=math.random()
  e2=math.random()
  if e1==0 then e1=e1+0.01 end
  eps=sigma*math.sqrt(-2*math.exp(e1))*math.cos(2*math.pi*e2)
end

p3=((s+Dividend)/R)+eps

--Intrinsic uncertainty delta
delta=(2*math.random()-1)*delta
uf=-(p3-pf0+delta)*(p3-pf0+delta)/(2*a)-C
ut=-(p3-pt0+delta)*(p3-pt0+delta)/(2*a)
u1=w*u1+uf
u2=w*u2+ut

s=math.exp(beta*u1)+math.exp(beta*u2)
n1=math.exp(beta*u1)/s
n2=1-n1

n2=n2*math.exp(-(p3-pstar)*(p3-pstar)/alpha)
n1=1-n2

r=(p3-p2)/p2

p0=p1
p1=p2
p2=p3



