pt1=960, pt2=950, pt3=990, pt4=980, u1=0, u2=0, yt1=1, yt2=1
beta=2, R=1.001, sigma=10, v=1, g=1.9, C=0, w=0.99, a=1, sd_div=0, mu=1, rho=0, alpha=555.555
pstar, n1, n2, r, u1, u2 
d
--Generate new dividend yt (y0) from AR(1) model, and new fundamental
e1=math.random()
e2=math.random()
if e1==0 then e1=e1+0.01 end
yt0=rho*yt1+mu+sd_div*math.sqrt(-2*math.log(e1))*math.cos(2*math.pi*e2)

--Calc. the math.expected fundamental values and math.expected dividends
e_pstar =(rho*rho*yt0+mu*rho)/(R-rho)+mu*R/((R-rho)*(R-1))
e_pstar1=(rho*rho*yt2+mu*rho)/(R-rho)+mu*R/((R-rho)*(R-1))
e_y  =rho*yt0+mu
e_yt1=rho*yt2+mu
pstar1=(rho*yt1/(R-rho))+mu*R/((R-rho)*(R-1))
pstar =(rho*yt0/(R-rho))+mu*R/((R-rho)*(R-1))

pf =e_pstar+v*(pt1-e_pstar)
pt =pt1+g*(pt1-pt2)
pf0=e_pstar1+v*(pt3-e_pstar1)
pt0=pt3+g*(pt3-pt4)

--evaluating performance measure
uf=(pt1+yt1-R*pt2)*(pf0+e_yt1-R*pt2)/a - C
ut=(pt1+yt1-R*pt2)*(pt0+e_yt1-R*pt2)/a
u1=w*u1+uf
u2=w*u2+ut

-- to avoid overflow of double precision numbers do not use exp()
m=math.tanh(beta/2*(u1-u2))
n1=(m+1)/2
n2=1-n1

n2=n2*math.exp(-((pt1-pstar1)/pstar1)*((pt1-pstar1)/pstar1)*alpha)
n1=1-n2

s=n1*pf+n2*pt

--Noisy equilibrium
e1=math.random()
e2=math.random()
if e1==0 then e1=e1+0.01 end
eps=sigma*math.sqrt(-2*math.log(e1))*math.cos(2*math.pi*e2)

pnew=(s+e_y+eps)/R

pt4=pt3
pt3=pt2
pt2=pt1
pt1=pnew


r=(pnew-pt1)/pt1





